## pam_usb-0.8.5.zip

=== Makefile ===
# Set to 'yes' to include debugging information, e.g. DEBUG=yes make -e
DEBUG := no

PREFIX ?= /usr
ARCH := $(shell uname -m)
UID := $(shell id -u)
GID := $(shell id -g)
USE_FEDORA_LIBDIR := $(shell test -d /lib64/security && echo 1 || echo 0)
VERSION := $(shell git for-each-ref --sort=creatordate --format '%(tag)' refs/tags | tail -n 1).$(shell git rev-list --count $(shell git for-each-ref --sort=creatordate --format '%(tag)' refs/tags | tail -n 1)..HEAD)

ifeq ($(ARCH), x86_64)
	ifeq ($(USE_FEDORA_LIBDIR), 1)
		LIBDIR ?= lib64
	else
		LIBDIR ?= lib/x86_64-linux-gnu
	endif
endif
ifeq ($(ARCH), i686)
	LIBDIR ?= lib
endif
ifeq ($(ARCH), aarch64) # ARM64, i.e Apple silicon and other up2date CPUs/SoCs
	LIBDIR ?= lib/aarch64-linux-gnu
endif
ifeq ($(ARCH), armv7l) # ARM32, i.e Raspberries
	LIBDIR ?= lib/arm-linux-gnueabihf
endif
ifeq ($(ARCH), m68k-linux-gnu) # Motorola 68k - Amiga forever
	LIBDIR ?= lib/m68k-linux-gnu
endif

# compiler/linker options
CC := gcc
CFLAGS := $(CFLAGS) -Wall -fPIC `pkg-config --cflags libxml-2.0` `pkg-config --cflags udisks2` #cflags libxml?
ifeq (yes, ${DEBUG})
	CFLAGS := ${CFLAGS} -ggdb
endif

LIBS := `pkg-config --libs libxml-2.0` `pkg-config --libs udisks2`

# common source files
SRCS := src/conf.c \
	src/mem.c \
	src/log.c \
	src/xpath.c \
	src/pad.c \
	src/volume.c \
	src/process.c \
	src/tmux.c \
	src/local.c \
	src/device.c
OBJS := $(SRCS:.c=.o)

# pam_usb
PAM_USB_SRCS := src/pam.c
PAM_USB_OBJS := $(PAM_USB_SRCS:.c=.o)
PAM_USB	:= pam_usb.so
PAM_USB_LDFLAGS := -shared
PAM_USB_DEST := $(DESTDIR)/$(LIBDIR)/security

# pamusb-check
PAMUSB_CHECK_SRCS := src/pamusb-check.c
PAMUSB_CHECK_OBJS := $(PAMUSB_CHECK_SRCS:.c=.o)
PAMUSB_CHECK := pamusb-check

# Tools
PAMUSB_CONF := pamusb-conf
PAMUSB_AGENT := pamusb-agent
PAMUSB_KEYRING_GNOME := pamusb-keyring-unlock-gnome
TOOLS_DEST := $(DESTDIR)$(PREFIX)/bin
TOOLS_SRC := tools

# Conf
CONFS := doc/pam_usb.conf
CONFS_DEST := $(DESTDIR)/etc/security

# Doc
DOCS := doc/CONFIGURATION doc/QUICKSTART doc/SECURITY doc/TROUBLESHOOTING
DOCS_DEST := $(DESTDIR)$(PREFIX)/share/doc/pam_usb

# Man
MANS := doc/pamusb-conf.1.gz doc/pamusb-agent.1.gz doc/pamusb-check.1.gz doc/pamusb-keyring-unlock-gnome.1.gz
MANS_DEST := $(DESTDIR)$(PREFIX)/share/man/man1

# PAM config
PAM_CONF := debian/pam-auth-update/usb
PAM_CONF_DEST := $(DESTDIR)$(PREFIX)/share/pam-configs

# Binaries
RM  := rm
INSTALL	:= install
MKDIR := mkdir
DEBUILD	:= debuild -b -uc -us --lintian-opts --profile debian
RPMBUILD := rpmbuild -v -bb --clean fedora/SPECS/pam_usb.spec
ZSTBUILD := cd arch_linux && makepkg -p PKGBUILD_git && cd ..
MANCOMPILE := gzip -kf
DOCKER := docker

all: manpages $(PAM_USB) $(PAMUSB_CHECK)

$(PAM_USB): $(OBJS) $(PAM_USB_OBJS)
	$(CC) -o $(PAM_USB) $(PAM_USB_LDFLAGS) $(LDFLAGS) $(OBJS) $(PAM_USB_OBJS) $(LIBS)

$(PAMUSB_CHECK): $(OBJS) $(PAMUSB_CHECK_OBJS)
	$(CC) -o $(PAMUSB_CHECK) $(LDFLAGS) $(OBJS) $(PAMUSB_CHECK_OBJS) $(LIBS)

%.o: %.c
	${CC} -c ${CFLAGS} $< -o $@

clean:
	$(RM) -f \
		$(MANS) \
		$(PAM_USB) \
		$(PAMUSB_CHECK) \
		$(OBJS) \
		$(PAMUSB_CHECK_OBJS) \
		$(PAM_USB_OBJS)

manpages:
	$(MANCOMPILE) ./doc/*.1

update-other-docs:
	wget https://raw.githubusercontent.com/wiki/mcdope/pam_usb/Configuration.md -O doc/CONFIGURATION > /dev/null 2>&1
	wget https://raw.githubusercontent.com/wiki/mcdope/pam_usb/Getting-Started.md -O doc/QUICKSTART > /dev/null 2>&1
	wget https://raw.githubusercontent.com/wiki/mcdope/pam_usb/Security.md -O doc/SECURITY > /dev/null 2>&1
	wget https://raw.githubusercontent.com/wiki/mcdope/pam_usb/Troubleshooting.md -O doc/TROUBLESHOOTING > /dev/null 2>&1
	git status --porcelain=v1 2>/dev/null && echo "Committing docs..." || { echo "Git staging area needs to be clean!"; exit 1; }
	git add \
		doc/CONFIGURATION \
		doc/QUICKSTART \
		doc/SECURITY \
		doc/TROUBLESHOOTING \
		 > /dev/null 2>&1
	git commit \
		--author="make update-other-docs <noemail@example.com>" \
		--signoff \
		-m "[Docs] Update non-manpage \"doc/\" files" \
		 > /dev/null 2>&1 || { git reset doc/CONFIGURATION doc/QUICKSTART doc/SECURITY doc/TROUBLESHOOTING; echo "No changes to commit."; }

install: all
	$(MKDIR) -p \
		$(CONFS_DEST) \
		$(DOCS_DEST) \
		$(MANS_DEST) \
		$(TOOLS_DEST) \
		$(PAM_USB_DEST)

	$(INSTALL) -m755 $(PAM_USB) $(PAM_USB_DEST)
	$(INSTALL) -m755 $(PAMUSB_CHECK) $(TOOLS_SRC)/$(PAMUSB_CONF) $(TOOLS_SRC)/$(PAMUSB_AGENT) $(TOOLS_SRC)/$(PAMUSB_KEYRING_GNOME) $(TOOLS_DEST)
	$(INSTALL) -m644 $(DOCS) $(DOCS_DEST)
	$(INSTALL) -m644 $(MANS) $(MANS_DEST)

	if test -d $(PAM_CONF_DEST); then $(INSTALL) -m644 $(PAM_CONF) $(PAM_CONF_DEST)/libpam-usb; fi
	if test -f $(CONFS_DEST)/pam_usb.conf; then $(INSTALL) -b -m644 $(CONFS) $(CONFS_DEST)/pam_usb.conf.dist; fi
	if test ! -f $(CONFS_DEST)/pam_usb.conf; then $(INSTALL) -b -m644 $(CONFS) $(CONFS_DEST); fi

# force pam-auth-update config install if building a deb
	if test $(DEB_TARGET_ARCH) != "" > /dev/null 2>&1; then mkdir -p $(PAM_CONF_DEST) && $(INSTALL) -m644 $(PAM_CONF) $(PAM_CONF_DEST)/libpam-usb; fi

deinstall:
	$(RM) -f $(PAM_USB_DEST)/$(PAM_USB)
	$(RM) -f \
		$(TOOLS_DEST)/$(PAMUSB_CHECK) \
		$(TOOLS_DEST)/$(PAMUSB_CONF) \
		$(TOOLS_DEST)/$(PAMUSB_AGENT) \
		$(TOOLS_DEST)/$(PAMUSB_KEYRING_GNOME) \
		$(PAM_CONF_DEST)/$(PAM_CONF)

	$(RM) -rf $(DOCS_DEST)
	$(RM) -f $(MANS_DEST)/pamusb-*\.1\.gz
	$(RM) -f $(PAM_CONF_DEST)/$(PAM_CONF)

uninstall: deinstall

changelog:
	git log --pretty=format:"%h %ad%x09%an%x09%s" --date=short 40b17fa..HEAD > changelog-from-v0.5.0

debchangelog:
	git log --pretty=format:"  * %s (%an <%ae>)" --date=short 40b17fa..HEAD > changelog-for-deb

builddir:
	mkdir -p .build > /dev/null 2>&1 || echo 0

deb: clean builddir
	$(DEBUILD)

deb-sign: build-debian
	debsign -S -k$(APT_SIGNING_KEY) `ls -t .build/*.changes | head -1`

rpm: clean builddir
	$(RPMBUILD)
	yes | cp -rf fedora/RPMS/$(ARCH)/*.rpm .build

rpm-sign: build-fedora
	rpm --addsign `ls -t .build/*.rpm | head -1`

rpm-lint: build-fedora
	rpmlint `ls -t .build/*.rpm | head -1`

zst: clean builddir
	rm -f arch_linux/*.zst
	$(ZSTBUILD)
	yes | cp -rf arch_linux/*.zst .build
	rm -rf arch_linux/pam_usb arch_linux/src arch_linux/pkg arch_linux/*.tar.gz arch_linux/*.zst

sourcegz: clean builddir
	tar --exclude="debian/.debhelper" \
		--exclude="debian/files" \
		--exclude="debian/libpam-usb/*" \
		--exclude="debian/libpam-usb.debhelper.log" \
		--exclude="debian/libpam-usb.substvars" \
		--exclude="debian/debhelper-build-stamp" \
		--exclude="debian/libpam-usb.postinst.debhelper" \
		--exclude="debian/libpam-usb.postrm.debhelper" \
		--exclude="debian/libpam-usb.prerm.debhelper" \
		--exclude="fedora/RPMS/x86_64" \
		--exclude="fedora/BUILD/*" \
		--exclude="tests" \
		--exclude=".build" \
		--exclude=".idea" \
		--exclude=".vscode" \
		--exclude=".github" \
		--exclude=".git" \
		-zcvf .build/pam_usb-$(VERSION).tar.gz .

buildenv-debian:
	$(DOCKER) build -f Dockerfile.debian -t mcdope/pam_usb-ubuntu-build .

buildenv-fedora:
	$(DOCKER) build -f Dockerfile.fedora -t mcdope/pam_usb-fedora-build .

buildenv-arch:
	$(DOCKER) build -f Dockerfile.arch -t mcdope/pam_usb-arch-build .

build-debian: buildenv-debian
	$(DOCKER) run -i \
		-v`pwd`/.build:/usr/local/src \
		-v`pwd`:/usr/local/src/pam_usb \
		--rm mcdope/pam_usb-ubuntu-build \
		sh -c "make deb && chown -R $(UID):$(GID) .build debian"

build-fedora: buildenv-fedora
	$(DOCKER) run -i \
		-v`pwd`/.build:/usr/local/src \
		-v`pwd`:/usr/local/src/pam_usb \
		--rm mcdope/pam_usb-fedora-build \
		sh -c "make rpm && chown -R $(UID):$(GID) .build fedora"

build-arch: buildenv-arch
	$(DOCKER) run -i \
		-v`pwd`/.build:/usr/local/src \
		-v`pwd`:/usr/local/src/pam_usb \
		--rm mcdope/pam_usb-arch-build \
		sh -c "chown -R builduser:builduser . && sudo -u builduser make zst && chown -R $(UID):$(GID) ."

=== debian/changelog ===
libpam-usb (0.8.5) unstable; urgency=medium
  * [Feature] Support multiple devices per user
  * [Enhancement] Misc. memory and string handling stuff
  * [Enhancement] Deny if pads can't be updated
  * [Enhancement] SELinux! Wiki now has a doc on how to create your own profile
  * [Bugfix] LC_ALL usage

 -- Tobias Bäumer <tobiasbaeumer@gmail.com>  Fri, 26 Jul 2024 21:00:00 +0200

libpam-usb (0.8.4) unstable; urgency=medium
  * [Bugfix] loginctl usage was not sh compatible
  * [Bugfix] Misc. fixes related to memory handling
  * [Enhancement] Don't check every element of ut_addr_v6
  * [Enhancement] Service whitelist is now user configurable
  * [Enhancement] Whitelist additions: lxdm, xscreensaver, klockscreen

 -- Tobias Bäumer <tobiasbaeumer@gmail.com>  Thu, 04 Jan 2024 21:00:00 +0100

libpam-usb (0.8.3-1) unstable; urgency=medium
  * [Bugfix] Fix pam-auth-update config not being included in package

 -- Tobias Bäumer <tobiasbaeumer@gmail.com>  Mon, 05 Sep 2022 21:00:00 +0200

libpam-usb (0.8.3) unstable; urgency=medium
  * [Feature] pamusb-conf now has a --reset-pads=username option
  * [Bugfix] Fix debconf issues with devices having no revision set
  * [Bugfix] Fix RHOST check triggering on empty value
  * [Bugfix] Whitelist pamusb-agent for remoteness-check
  * [Bugfix] Fix "tty from displayserver" remoteness-check method
  * [Docs] Update manpages and text files
  * [Bugfix] Fix some usages of tmux being able to circumvent localcheck

 -- Tobias Bäumer <tobiasbaeumer@gmail.com>  Tue, 30 Aug 2022 21:00:00 +0200

libpam-usb (0.8.2) unstable; urgency=medium
  * [Tools/Docs] Add pamusb-keyring-unlock-gnome, to allow unlocking the
  GNOME keyring (#11)
  * [Bugfix] Whitelist "login" service name to prevent insta-logout on
  TTY shells (#115)
  * [Bugfix] Check PAM_RHOST if deny_remote is enable to fix vsftpd auth
  breaking down (#100)
  * [Bugfix] Fix type for argument to stat (community contribution)
  * [Docs] Added code of conduct (#106) and updated AUTHORS
  * [Makefile] Fix LIBDIR on non-debian systems

 -- Tobias Bäumer <tobiasbaeumer@gmail.com>  Sun, 15 May 2022 21:00:00 +0200

libpam-usb (0.8.1) unstable; urgency=medium
  * [CI] Fixed "build & test on own server" job
  * [Enhancement] Fix obtaining tty by DISPLAY if DISPLAY contains a screen 
    identifier
  * [Enhancement] Whitelist policykit since obtaining the session tty is 
    impossible in some scenarios (exploiting would require an already 
    authenticated session)
  * [Enhancement] Indicate to tmux we specify an id by prepending it with '$'
  * [Enhancement] Fix versioning information
  * [Enhancement] Fix compatibility with Wayland
  * [Enhancement] Allow execution of complex commands in pamusb-agent

 -- Tobias Bäumer <tobiasbaeumer@gmail.com>  Thu, 04 Nov 2021 18:00:00 +0100

libpam-usb (0.8.0) unstable; urgency=high

  * [SECURITY!] Massive rework of local check, now properly denies when remote 
    clients are connected via multiplexers (tmux, screen). Many thanks to 
    Github user @fuseteam for extensive testing [issue #51]
  * [Enhancement] Whitelisted most login managers for local check
  * [Enhancement] Agent: workaround for devices being disconnected because of 
    power management events (thx to Github user @uszie)
  * [Bugfix] fixed pad file syncing behaviour during heavy file IO [issue #57]
  * [Enhancement] Added version info to pamusb-conf and pamusb-check

 -- Tobias Bäumer <tobiasbaeumer@gmail.com>  Wed, 01 Sep 2021 18:00:00 +0200

libpam-usb (0.7.3) unstable; urgency=high

  * Reworked deny_remote option
  * Removed unknown_pts_as_local option (not needed anymore)

 -- Tobias Bäumer <tobiasbaeumer@gmail.com>  Sat, 13 Feb 2021 22:23:34 +0100

libpam-usb (0.7.2) unstable; urgency=high

  * Works with libpam >= 1.4.0 / installs to correct target directory
  * Fix Lintian error 'bad-distribution-in-changes-file' on non-Ubuntu
  * Fix spelling error in debian/copyright
  * Change default value for unknown_pts_as_local to false

 -- Tobias Bäumer <tobiasbaeumer@gmail.com>  Fri, 12 Feb 2021 23:52:34 +0100

libpam-usb (0.7.1) unstable; urgency=medium

  * Added missing dependencies
  * Fix volume count detection in configure scripts
  * Fix NVMe volume handling in configure scripts
  * Fix pamusb-conf allowing to add multiple devices per user
  * Add rudimentary automated testing

 -- Tobias Bäumer <tobiasbaeumer@gmail.com>  Thu, 31 Dec 2020 11:52:34 +0200

libpam-usb (0.7.0) unstable; urgency=medium

  * Re-release - Uses github.com/mcdope/pam_usb as source
  * Ported to Python 3
  * pamusb-agent is now a systemd unit
  * pamusb-agent config can now hold environment vars
  * pamusb-conf got new options for automation
    (--list-devices, --list-volumes, --device, --volume, --yes)
  * pamusb-conf now properly ignores read-only media (like optical drives)
  * Support for devices lacking vendor and/or model
  * PAM module gets installed using libpam-runtime/pam-auth-update
  * Using debconf to create fully working config on install
  * Documentation / example config updated
  * Wiki (https://github.com/mcdope/pam_usb/wiki) updated

 -- Tobias Bäumer <tobiasbaeumer@gmail.com>  Thu, 20 Aug 2020 10:22:34 +0200

libpam-usb (0.6.0-5) unstable; urgency=medium

  * Initial release - Uses github.com/luka-n/pam_usb as source (0.5.0, ported to UDisks2)

 -- Adrian Nöthlich <promasu@ox.io>  Sun, 07 Jan 2018 22:22:34 +0100

libpam-usb (0.5.0-4) unstable; urgency=low

  * Attempt to fix FTBFS on hurd.
  * Make this depending on udisks on linux-any only.
  * Increase entropy of generated pad files (Closes: #658700);
    thanks to Toby Speight for the patch.
  * Add config file for pam-auth-update (Closes: #658967);
    thanks to Petter Reinholdtsen for the report.
    - Add libpam-runtime (>= 1.0.1-6~) on Pre-Depends due to the use of the
      pam-auth-update tool in the maintainer scripts.
  * Add NEWS file to inform users about the need for rewriting their config


=== debian/control ===
Source: libpam-usb
Section: admin
Priority: optional
Maintainer: Tobias Bäumer <tobiasbaeumer@gmail.com>
Build-Depends: debhelper (>= 10), devscripts, libxml2-dev, libpam0g-dev, libudisks2-dev, pkg-config, libglib2.0-dev
Standards-Version: 4.5.0
Homepage: https://github.com/mcdope/pam_usb

Package: libpam-usb
Architecture: any
# Multi-Arch: same
Pre-Depends: libpam-runtime (>= 1.0.1-6~), ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}, python3, python3-gi, udisks2, gir1.2-udisks-2.0, libpam0g, libxml2, libglib2.0-0, gawk
Description: Adds auth over usb-stick to pam
 Provides a new pam module, pam_usb.so, that can be used in pam.d/common-auth

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with=systemd

override_dh_installinit:
	dh_systemd_enable -plibpam-usb --name=pamusb-agent pamusb-agent.service
	dh_installinit -plibpam-usb --no-start --noscripts
	dh_systemd_start -plibpam-usb --no-restart-on-upgrade

override_dh_systemd_start:
	echo "Not running dh_systemd_start"
